package client.gui.ingame;

import client.gui.Gui;
import client.gui.element.ActButton;
import client.gui.element.ButtonCallback;
import common.color.TextColor;
import client.gui.element.Label;
import client.gui.element.PressType;

public class GuiGameOver extends Gui {
	public static final GuiGameOver INSTANCE = new GuiGameOver();
	
	private ActButton button;
	private int timer;
	
	private GuiGameOver() {
	}

	public void init(int width, int height) {
		this.timer = 0;
		this.add(new Label(0, 0, 200, 20, "Du bist gestorben!"));
		this.add(new Label(0, 32, 200, 20, "Punktestand: " + TextColor.YELLOW + this.gm.player.experienceLevel));
		this.button = this.add(new ActButton(0, 100, 200, 24, new ButtonCallback() {
			public void use(ActButton elem, PressType action) {
				GuiGameOver.this.gm.player.respawnPlayer();
				GuiGameOver.this.gm.displayGuiScreen(null);
			}
		}, "Wiederbeleben"));
		this.shift();
		this.button.enabled = false;
	}
	
	public String getTitle() {
		return "Game over";
	}
	
	public void updateScreen() {
		if(++this.timer >= 20)
			this.button.enabled = true;
	}
}
