package common.network;

import io.netty.buffer.ByteBuf;
import io.netty.channel.ChannelHandlerContext;
import io.netty.handler.codec.MessageToMessageDecoder;
import java.util.List;
import javax.crypto.Cipher;
import javax.crypto.ShortBufferException;

public class NettyEncryptionDecoder extends MessageToMessageDecoder<ByteBuf> {
	private final EncryptionCodec codec;

	public NettyEncryptionDecoder(Cipher cipher) {
		this.codec = new EncryptionCodec(cipher);
	}

	protected void decode(ChannelHandlerContext p_decode_1_, ByteBuf p_decode_2_, List<Object> p_decode_3_) throws ShortBufferException, Exception {
		p_decode_3_.add(this.codec.decipher(p_decode_1_, p_decode_2_));
	}
}
